(define (vector-swap! vec i j)
  (let ([elem (vector-ref vec i)])
    (vector-set! vec i (vector-ref vec j))
    (vector-set! vec j elem)))

(define (permute vec len i)
  (cond
    [(= len i) void]
    [else (let ([j (+ (random (- len i)) i)])
            (vector-swap! vec i j)
            (permute vec len (+ i 1)))]))                 

(define (make-perms vec len n)
  (cond
    [(zero? n) '()]
    [else (begin
            (permute vec len 0)
            (cons (vector->list vec) (make-perms vec len (- n 1))))]))

; rand-perms : (listof 'a) number -> (listof (listof 'a))
(define (rand-perms L n)
  (let* ([vec (list->vector L)]
         [len (vector-length vec)])
    (make-perms vec len n)))

; (rand-perms '(1 2 3) 20)