(require-library "functios.ss")

(define-signature context^
  ; tag = 'B | 'EM | 'I | 'PL | 'S | 'TT | 'U | real-size | real-color
  ; color = 'root | real-color
  ; real-color = 'r | 'g | 'b | 'c | 'm | 'y | 'k | 'w
  ; size = 'root | real-size
  ; real-size = '|0| '|1| '|2| '|3| '|4| '|5| '|6| '|7| '|8| '|9|

  (initial-context ; context
   context? ; tst -> bool
   
   ; selectors
   is-b? is-em? is-i? is-s? is-tt? ; context -> bool
   get-underline ; context -> nat
   get-color ; context -> color
   get-size ; context -> sym
   
   context-open-tag ; context tag -> context
   space-context ; context -> context
   display-context ; context -> void
   
  initial-meaning
  (struct meaning (context str) -setters)
  (struct meaning/space ())
   ))

(define-signature io^
  ; meaning = (make-meaning context str) | (make-meaning/space context str)
  (read-vectors ; iport -> (vectorof meaning) (vectorof (cons nat (listof sym)))
   ))

(define-signature timer^
  (update-if-better ; (vectorof (cons nat (listof sym))) nat -> void
   run ; -> void
   update-tree
   ))

; an imaginary unit from rob:
(define-signature search^
  (warn-search ; (-> void)
   search ; (vectorof meaning)
          ; -> void
   rob-cost ; (vectorof (cons nat (listof sym))) nat -> nat  
  ))

(define-signature opts^
  (run-all-opts))

; an imaginary unit from dreiss:
(define-signature incremental^
  ; tree is an abstract data type up to dave
  (print-tree ; tree -> void
   parse-to-tree ; (vectorof meaning)
                 ; (vectorof (cons nat (listof sym)))
                 ; -> tree
  ))
