(load "genperms.ss")
(load "randperm.ss")

; goes-true? : (context -> boolean) context context -> boolean
(define (goes-true? pred old-c new-c)
  (and (not (pred old-c)) (pred new-c)))

; goes-false? : (context -> boolean) context context -> boolean
(define (goes-false? pred old-c new-c)
  (and (pred old-c) (not (pred new-c))))

; u-decreases? : context context -> boolean
(define (u-decreases? old-c new-c)
  (> (get-underline old-c) (get-underline new-c)))

; generate-<U>s : context context -> (listof symbol)
(define (generate-<U>s old-c new-c)
  (define (gen x)
    (cond
      [(zero? x) '()]
      [else (cons 'U (gen (- x 1)))]))
  (gen (- (get-underline new-c) (get-underline old-c))))

; is-diff? : (context -> symbol) context context -> boolean
(define (is-diff? sel old-c new-c)
  (not (symbol=? (sel old-c) (sel new-c))))

; need-<PL>?/space context context -> boolean
(define (need-<PL>?/space old-c new-c)
  (or (goes-false? is-tt? old-c new-c)
      (u-decreases? old-c new-c)))

; need-<PL>?/nospace context context -> boolean
(define (need-<PL>?/nospace old-c new-c)
  (or (goes-false? is-b? old-c new-c)
      (goes-false? is-i? old-c new-c)
      (goes-false? is-s? old-c new-c)
      (goes-false? is-tt? old-c new-c)
      (and (goes-false? is-em? old-c new-c) (not (is-s? new-c)))
      (u-decreases? old-c new-c)))

; decide-perms : (listof symbol) -> (listof (listof symbol})
(define (decide-perms tag-L)
  (cond
    [(<= (length tag-L) 3) (gen-perms tag-L)]
    [else (rand-perms tag-L 10)]))

; <PL>ize : boolean (listof (listof symbol))) -> (listof (listof symbol))
(define (<PL>ize need-<PL> tag-LL)
  (cond
    [need-<PL> (map (lambda (tag-L) (cons 'PL tag-L)) tag-LL)]
    [else tag-LL]))

; tags/space : context context -> (listof (listof symbol))
(define (tags/space old-c new-c)
  (let ([need-<PL> (need-<PL>?/space old-c new-c)])
    (when need-<PL>
      (set! old-c (context-open-tag old-c 'PL)))
    (let ([tags (generate-<U>s old-c new-c)])
      (when (and (is-diff? get-color old-c new-c)
                 (> (get-underline new-c) 0))
        (set! tags (cons (get-color new-c) tags)))
      (when (is-diff? get-size old-c new-c)
        (set! tags (cons (get-size new-c) tags)))
      (when (goes-true? is-tt? old-c new-c)
        (set! tags (cons 'TT tags)))
      (<PL>ize need-<PL> (decide-perms tags)))))

; tags/nospace : context context -> (listof (listof symbol))
(define (tags/nospace old-c new-c)
  (let ([need-<PL> (need-<PL>?/nospace old-c new-c)])
    (when need-<PL>
      (set! old-c (context-open-tag old-c 'PL)))
    (let ([tags (generate-<U>s old-c new-c)])
      (when (is-diff? get-color old-c new-c)
        (set! tags (cons (get-color new-c) tags)))
      (when (is-diff? get-size old-c new-c)
        (set! tags (cons (get-size new-c) tags)))
      (when (goes-true? is-b? old-c new-c)
        (set! tags (cons 'B tags)))
      (when (goes-true? is-i? old-c new-c)
        (set! tags (cons 'I tags)))
      (when (goes-true? is-s? old-c new-c)
        (set! tags (cons 'S tags)))
      (when (goes-true? is-em? old-c new-c)
        (set! tags (cons 'EM tags)))
      (when (goes-true? is-tt? old-c new-c)
        (set! tags (cons 'TT tags)))
      (<PL>ize need-<PL> (decide-perms tags)))))

; color-or-size-becomes-root? : context context -> boolean
(define (color-or-size-becomes-root? old-c new-c)
  (or (and (not (symbol=? (get-color old-c) 'root))
           (symbol=? (get-color new-c) 'root))
      (and (not (symbol=? (get-size old-c) 'root))
           (symbol=? (get-size new-c) 'root))))

; tags-to-diff-context : context context boolean -> (listof (listof symbol))
(define (tags-to-diff-context old-c new-c new-c-is-space)
;  (when (not (and (context? old-c) (context? new-c)))
;    (error "give tags-to-diff-context two contexts!!!"))
  (cond
    [(color-or-size-becomes-root? old-c new-c) '()]
    [new-c-is-space (tags/space old-c new-c)]
    [else (tags/nospace old-c new-c)]))