
;; updates! the contents of the tags vector is now a cons cell whose car is
;; an integer with the number of tages popped off, and whose cdr is a list
;; of symbols (tags that are opening)

;; a tree is either a string or a list containing an initial symbol (the
;; tag) then a list of trees.
;; the top level of the document has a (fake) initial symbol of 'TOP


;; getting the ups and downs
(define get-ups car)
(define get-downs cdr)


;;; takes a vector of meanings (n elts) and a vector of tags (n+1 elts)
;;; each tag is a cons of an integer and a list of symbols
;(define (parse-to-tree strings tags)
;  (letrec
;      ((do-up
;        (lambda (ups i)
;          (if (zero? ups)
;              (do-down (get-downs (vector-ref tags i)) i)
;              (cons '() (do-up (- ups 1) i)))))
;       (do-down
;        (lambda (downs i)
;          (if (= i (vector-length strings))
;              '(())
;              (if (null? downs)
;                  (do-string i)
;                  (let ((r (do-down (cdr downs) i)))
;                    (cons (cons (cons (car downs) (car r))
;                                (cadr r))
;                          (cddr r)))))))
;       (do-string
;        (lambda (i)
;          (let ((r (do-up (get-ups (vector-ref tags (+ i 1))) (+ i 1))))
;            (cons (cons (meaning-str (vector-ref strings i)) (car r))
;                  (cdr r)))))       )
;    (cons 'TOP (car (do-down (get-downs (vector-ref tags 0)) 0)))))


;; takes a tree as described above
(define (print-tree tree)
  (letrec
      ((print-list
        (lambda (lst out)
          (unless (null? lst)
            (print-tree-real (car lst) out)
            (print-list (cdr lst) out))))
       (print-tree-real
        (lambda (tree out)
          (cond ((string? tree) (display tree out))
                ((list? tree)
                 (fprintf out "<~a>" (car tree))
                 (print-list (cdr tree) out)
                 (fprintf out "</~a>" (car tree)))))))
    (if (string? tree)
        (display tree)
        (print-list (cdr tree) (current-output-port)))))





; parse-to-tree : (vectorof meaning) (vectorof (cons nat (listof sym))) -> (listof tree)
(define (parse-to-tree strings tags)
  (letrec ((do-up
            (lambda (k ups i)
              (if (zero? ups)
                  (do-down k (get-downs (vector-ref tags i)) i)
                  (do-up (lambda (a) (k (cons '() a)))
                         (- ups 1) i))))
           (do-down
            (lambda (k downs i)
              (if (= i (vector-length strings))
                  (k '(()))
                  (if (null? downs)
                      (do-string k i)
                      (do-down (lambda (r)
                                 (k (cons (cons (cons (car downs) (car r))
                                                (cadr r))
                                          (cddr r))))
                               (cdr downs) i)))))
           (do-string
            (lambda (k i)
              (do-up (lambda (r)
                       (k (cons (cons (meaning-str (vector-ref strings i)) (car r))
                                (cdr r))))
                     (get-ups (vector-ref tags (+ i 1)))
                     (+ i 1)))))
    (do-down (lambda (a)
               (cons 'TOP (car a)))
             (get-downs (vector-ref tags 0)) 0)))

